import { prisma } from "@/module/_global";
import { funGetUserById } from "@/module/auth";
import { createLogUserMobile } from "@/module/user";
import { NextResponse } from "next/server";

// ADD LINK PROJECT
export async function POST(request: Request, context: { params: { id: string } }) {
   try {
      const { id } = context.params
      const { link, user } = (await request.json())

      const userMobile = await funGetUserById({ id: String(user) })

      if (userMobile.id == "null" || userMobile.id == undefined || userMobile.id == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const data = await prisma.project.count({
         where: {
            id: id
         }
      })

      if (data == 0) {
         return NextResponse.json(
            {
               success: false, message: "Gagal mendapatkan kegiatan, data tidak ditemukan",
            },
            { status: 200 }
         );
      }


      const insertLink = await prisma.projectLink.create({
         data: {
            idProject: id,
            link: link
         }
      })

      // create log user
      const log = await createLogUserMobile({ act: 'CREATE', desc: 'User menambah link kegiatan', table: 'projectLink', data: insertLink.id, user: userMobile.id })
      return NextResponse.json({ success: true, message: "Berhasil menambahkan link kegiatan" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menambah link kegiatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}


// DELETE LINK PROJECT
export async function DELETE(request: Request, context: { params: { id: string } }) {
   try {
      const { idLink, user } = (await request.json())

      const userMobile = await funGetUserById({ id: String(user) })

      if (userMobile.id == "null" || userMobile.id == undefined || userMobile.id == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const data = await prisma.projectLink.count({
         where: {
            id: idLink
         }
      })

      if (data == 0) {
         return NextResponse.json(
            {
               success: false, message: "Gagal mendapatkan link, data tidak ditemukan",
            },
            { status: 200 }
         );
      }

      const deleteLink = await prisma.projectLink.update({
         where: {
            id: idLink
         },
         data: {
            isActive: false
         }
      })

      // create log user
      const log = await createLogUserMobile({ act: 'DELETE', desc: 'User menghapus link kegiatan', table: 'projectLink', data: String(idLink), user: userMobile.id })
      return NextResponse.json({ success: true, message: "Berhasil menghapus link kegiatan" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menghapus link kegiatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}
